/* Dia -- an diagram creation/manipulation program
 * Copyright (C) 1998 Alexander Larsson
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef __MUL_H
#define __MUL_H



#define MUL_DEFAULT_WIDTH 2.0
#define MUL_DEFAULT_HEIGHT 1.0
#define MUL_TEXT_BORDER_WIDTH_X 0.2
#define MUL_TEXT_BORDER_WIDTH_Y 0.3
#define MUL_FONT_HEIGHT 0.8


typedef struct _Mul Mul;
typedef struct _MulState MulState;
typedef struct _MulPropertiesDialog MulPropertiesDialog;

struct _MulPropertiesDialog
{
	GtkWidget *dialog;

	GtkMenu *task_menu;
	GtkOptionMenu *task_omenu;

	TaskPropertiesDialog* task[2];

	DiaColorSelector *fg_color;
	DiaColorSelector *bg_color;
};

struct _MulState
{
	Color border_color;
	Color inner_color;

	GSList *tasks;
};

struct _Mul {
  Element element;

  ConnectionPoint connections[8];

  Color border_color;
  Color inner_color;
  
  int nb_tasks;
  Task *nulltask;
  GSList *tasks;

  MulPropertiesDialog *properties_dialog;
};

//common functions
void mul_update_data(Mul *mul);


#endif //__MUL_H
