/* Dia -- an diagram creation/manipulation program
 * Copyright (C) 1998 Alexander Larsson
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef __STASK_H
#define __STASK_H


#define STASK_DEFAULT_WIDTH 2.0
#define STASK_DEFAULT_HEIGHT 1.0
#define STASK_TEXT_BORDER_WIDTH_X 0.2
#define STASK_TEXT_BORDER_WIDTH_Y 0.3
#define STASK_FONT_HEIGHT 0.8


typedef struct _Stask Stask;
typedef struct _StaskState StaskState;
typedef struct _StaskPropertiesDialog StaskPropertiesDialog;

struct _StaskPropertiesDialog
{
	GtkWidget *dialog;

	TaskPropertiesDialog *task;
};

struct _StaskState
{
//	ObjectState obj_state;

	Task* task;
};

struct _Stask {
	Element element;

	ConnectionPoint connections[8];

	Task *task;

	StaskPropertiesDialog* properties_dialog;
};


//common functions
void stask_update_data(Stask *task);


#endif //__STASK_H
