/* Dia -- an diagram creation/manipulation program
 * Copyright (C) 1998 Alexander Larsson
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef __SUM_H
#define __SUM_H



#define SUM_DEFAULT_WIDTH 2.0
#define SUM_DEFAULT_HEIGHT 1.0
#define SUM_TEXT_BORDER_WIDTH_X 0.2
#define SUM_TEXT_BORDER_WIDTH_Y 0.3
#define SUM_FONT_HEIGHT 0.8


typedef struct _Sum Sum;
typedef struct _SumState SumState;
typedef struct _SumPropertiesDialog SumPropertiesDialog;

typedef enum { OP_EQ, OP_DIFF, OP_LT, OP_LET, OP_GT, OP_GET } SumOp;

struct _SumPropertiesDialog
{
	GtkWidget *dialog;

	TaskPropertiesDialog* task[2];

	GtkWidget *toggle;
	GtkWidget *omenu1;
	GtkMenu *menu1;
	GtkWidget *omenu2;
	GtkMenu *menu2;
	GtkWidget *radio1;
	GtkWidget *omenu3;
	GtkMenu *menu3;
	GtkWidget *radio2;
	GtkWidget *spin;
	GtkWidget *omenu4;
	GtkMenu *menu4;
	GtkWidget *omenu5;
	GtkMenu *menu5;

	DiaColorSelector *fg_color;
	DiaColorSelector *bg_color;
};

struct _SumState
{
	Color border_color;
	Color inner_color;

	DiaFont *font;

	Task* task[2];

	int determinist;
	Task *tif1;
	SumOp op;
	Task *tif2;
	int value;
	real rif2;
	Task *tthen;
	Task *telse;
};

struct _Sum {
  Element element;

  ConnectionPoint connections[8];

//  real border_width;
  Color border_color;
  Color inner_color;
  
  DiaFont *font;

  Task* task[2];

  int determinist;
  Task *tif1;
  SumOp op;
  Task *tif2;
  int value;
  real rif2;
  Task *tthen;
  Task *telse;

  SumPropertiesDialog *properties_dialog;
};

//common functions
void sum_update_data(Sum *sum);


#endif //__SUM_H
