//task.h



#ifndef __TASK_H
#define __TASK_H


/*#define DEFAULT_WIDTH 2.0
#define DEFAULT_HEIGHT 3.0
#define TEXT_BORDER_WIDTH_X 0.2
#define TEXT_BORDER_WIDTH_Y 0.3*/
//#define TEXT_BORDER_WIDTH_X 0.7
//#define TEXT_BORDER_WIDTH_Y 0.5
#define TASK_FONT_HEIGHT 0.8



typedef struct _Task Task;

typedef enum {
	TASK_PRIMITIVE,
	TASK_COMPOSITE
} TaskType;

typedef enum {
	TASK_WITH_CORBA,
	TASK_WITHOUT_CORBA
} ModuleType;

typedef struct _TaskPropertiesDialog TaskPropertiesDialog;
typedef struct _TaskModulesWindow TaskModulesWindow;

struct _TaskPropertiesDialog
{
	GtkWidget *dialog;

	GtkEntry *name;
	GtkMenu *type_menu;
	GtkOptionMenu *type_omenu;

	GtkWidget* modules_button;

	DiaColorSelector *fg_color;
	DiaColorSelector *bg_color;
};

struct _TaskModulesWindow
{
	GtkWidget* window;

	GtkWidget* label;
	GtkWidget* toggle;

	GtkEntry* servername;
	GtkWidget* corbaobjectname;
	GtkWidget* corbamethodname;
	GtkWidget* labelo;
	GtkWidget* labelm;

	GtkWidget* button;
	GtkWidget* check;
};

struct _Task
{
	char *name;
	DiaFont *font;
	real name_width;

	TaskType type;

	TaskPropertiesDialog *properties_dialog;
	TaskModulesWindow *modules_window;

	char* servername;
	int usescorba;
	char* corbaobjectname;
	char* corbamethodname;
	int usespaco;

	Color border_color;
	Color inner_color;
};

/* task functions */
/* task ops */
/* removes a task from memory */
void task_destroy(Task *task);
/* duplicates a task */
Task* task_copy(Task *task);

/* task functions */
/* creates a task */
Task* task_create(void *user_data);
/* loads a task from a file */
Task* task_load(ObjectNode obj_node, int version, const char *filename, short i);
/* saves a task to a file */
void task_save(Task *task, ObjectNode obj_node, const char *filename, short i);


#endif //__TASK_H
